//<#!@READ-ONLY-SECTION-START@!#>
/*!
 * \class cfm_consumer
 * \brief Intel(R) CoFluent(TM) Studio - Intel Corporation
 * \details Simulation model of VulcanoApp generated by C++ Generator for SystemC/TLM2
 */

#ifndef COFS_MODEL_VULCANOAPP_CONSUMER
#define COFS_MODEL_VULCANOAPP_CONSUMER

#include "cfm_vulcanoapp_global.h"
#include "cfm_vulcanoapp_global_types.h"
#include "cofluent.h"

//<#!@READ-ONLY-SECTION-END@!#>
//Start of 'Consumer includes' algorithm generated code

//End of 'Consumer includes' algorithm generated code
//<#!@READ-ONLY-SECTION-START@!#>

///    \defgroup dxgConsumer Function Consumer
//@{
///        \page dxpConsumer
//@{
///    \brief Consumer function model.
class cfm_consumer: public cf_core::cf_function {
public:
	SC_HAS_PROCESS (cfm_consumer);

	/// ports typedef
	typedef cf_core::cf_mq_initiator_socket<cfm_consumer,
			cf_core::cf_payload_int> p_mq_changedQ_t;

	/// constructor
	cfm_consumer(sc_core::sc_module_name name);

	/// destructor
	virtual ~cfm_consumer(void);
	virtual void cb_before_elaboration(void);

public:
	/// \name input/output ports
	//@{
	p_mq_changedQ_t p_mq_changedQ;
	//@}

protected:
	/// initialize attributes
	void cb_init_attributes(void);
	/// initialize definitions
	void cb_init_local_vars(void);

	/// behavior
	void cfm_behavior();
	/// consume operation
	void cfm_op_consume();
	/// init operation
	void cfm_op_init();

protected:
	/// \name operations
	//@{
	cf_core::cf_operation consume;
	cf_core::cf_operation init;
	//@}

private:
	/// \name input/output local buffers
	//@{
	int changedQ;
	cf_core::cf_payload_int changedQ_trans;
	//@}

	/// \name user-defined local declarations
	//<#!@READ-ONLY-SECTION-END@!#>
	//Start of 'Consumer local declarations' algorithm generated code

	//End of 'Consumer local declarations' algorithm generated code
	//<#!@READ-ONLY-SECTION-START@!#>

};

//@}
//@}
#endif // COFS_MODEL_VULCANOAPP_CONSUMER

//<#!@READ-ONLY-SECTION-END@!#>